% LINK INTERESSANTE A UN BREVE CORSO DI STATISTICA:
% https://www.youtube.com/playlist?list=PL568547ACA9211CCA

clc;
clear;
close all;
rng('default')

%% Teorema del limite centrale
nSamples = 10000; % numero di campioni per distribuzione
nDistribution = 1000; % numero di distribuzioni
x = rand(nSamples,nDistribution)-0.5; % genero una matrice [nSamples x nDistribution]
                                      % con distribuzione uniforme da -0.5
                                      % a 0.5
x_r = reshape(x,[],1); % riarrangio la matrice x su un'unica colonna

x_mean = mean(x); % creo il vettore delle medie delle nDistribution distribuzioni

figure
histogram(x_r) % istogramma dei dati creati
title('distribuzione dei dati in ingresso')

figure
histogram(x_mean) % istogramma delle distribuzioni delle medie
                  % di ciascuna colonna di x
title('distribuzione delle medie');

figure
histfit(x_mean)
title('interpolazione con distribuzione normale');

pd = fitdist(x_mean','Normal');

mean_xr = mean(x_r); % media dei dati
std_xr = std(x_r); % deviazione standard dei dati

mean_x_mean = mean(x_mean); % media delle medie
std_x_mean = std(x_mean); % deviazione standard delle medie

sem = std_xr/sqrt(nSamples); % standard error of the mean

%% Teorema del limite centrale (altro esempio)
y = x.^2;
y_r = reshape(y,[],1); % riarrangio la matrice x su un'unica colonna

figure
histogram(y_r) % istogramma dei dati creati
title('distribuzione dei dati in ingresso elevati al quadrato')

y_mean = mean(y);

figure
histfit(y_mean) % istogramma delle distribuzioni delle medie
                % di ciascuna colonna di y
title('distribuzione delle medie dei dati al quadrato');


%% Esercizio sul chi quadro
clc;
clear;
close all;

x = [zeros(2,1); ones(3,1); 2*ones(7,1);...
    3*ones(9,1); 4*ones(11,1); 5*ones(10,1);...
    6*ones(8,1); 7*ones(4,1); 8*ones(3,1);...
    9*ones(2,1); 10*ones(1,1)];

nSamples = length(x);

% Mostro l'istogramma dei dati
figure
histogram(x); 

% Calcolo media e varianza
mu = mean(x);
sigma = std(x);

% calcolo i limiti degli intervalli
edges = min(x)-0.5:max(x)+1;
edges = edges';

% normalizzo i dati
z = (edges-mu)./sigma;

%%%%%%%%%%%%%%%%%%
% plotto la pdf e la cdf con mu = 0 e sigma = 1
a = -3:0.01:3;
b = normpdf(a,0,1);
figure
plot(a,b);

pd = makedist('Normal');
c = cdf(pd,a);

figure
plot(a,c);
%%%%%%%%%%%%%%%%%%

fa = zeros(length(z)+1,1);

fa(1) = normcdf(z(1));
fa(end) = 1 - normcdf(z(end));

for ii=1:length(z)-1
    p = normcdf([z(ii) z(ii+1)]);
    fa(ii+1) = p(2) - p(1);
end

fa = nSamples*fa;

fo = histcounts(x);
fo = fo';

ii = 1;

while sum(fo(1:ii)) < 5
    ii = ii + 1;
end

jj = length(fo);

while sum(fo(end:-1:jj)) < 5
    jj = jj - 1;
end

tmp = [sum(fo(1:ii)); fo(ii+1:jj-1); sum(fo(jj:end))];
tmp2 = [sum(fa(1:ii+1)); fa(ii+2:jj); sum(fa(jj+1:end))];

fo = tmp';
fa = tmp2';

chi_2 = sum(((fa-fo).^2)./fa);

[h,p,st] = chi2gof(x,'Edges',edges')

%% Correlazione
clc;
clear;
close all;

X = randn(50,1);
Y = zeros(size(X));

% correlo i dati con una retta e aggiungo del rumore
for ii=1:length(X)
    Y(ii) = 1.5*X(ii)+ 1.0 + 0.25*randn(1,1);
end

%Y = randn(size(X));

% plotto i dati
figure
plot(X,Y,'.');

X_mean = mean(X);
Y_mean = mean(Y);

% Formula della correlazione di Pearson
r = sum((X-X_mean).*(Y-Y_mean))/sqrt((sum((X-X_mean).^2))*(sum((Y-Y_mean).^2)));

% Funzione che calcola la correlazione di Pearson in MATLAB
[rho,pval] = corr(X,Y);


% polyfit: funzione che fitta i dati con una retta
c = polyfit(X,Y,1);
% mostro l'equazione trovata y = m*x + b
disp(['Equation is y = ' num2str(c(1)) '*x + ' num2str(c(2))])
% Valuto la retta trovata nei punti contenuti in X (uso la funzione
% polyval)
Y_est = polyval(c,X);
% aggiungo la retta alla figura
hold on
plot(X,Y_est,'r','LineWidth',2)
hold off
legend('dati sperimentali', 'fitting', 'Location','best')
axis equal

